#ifndef MODULES_H
#define MODULES_H

#ifdef USE_LTDL
#include <ltdl.h>
#else
typedef void *lt_dlhandle; // dummy
#endif
#include "lists.h"
#include "interp.h"

DEFLIST(library,
		char *name;
		lt_dlhandle handle;
		);

DEFLIST(mod_attach,
		interpreter *i;
		void *data;
		);

DEFLIST(module,
		char *name;
		lt_dlhandle handle;
		mod_attach *attached;
		);

DEFLIST(denied_module,
		interpreter *i;
		char *name;);

typedef void (*mod_init_f)(module *mod);
typedef void (*mod_attach_f)(mod_attach *ma);

#define SL_MOD_PATH_ENV ("SL_MOD_PATH")
#define SL_SCM_PATH_ENV ("SL_SCM_PATH")
#define DEFAULT_MOD_PATH "/usr/local/lib/nsl/modules"

library *load_library(char *name);
module *load_module(char *name);
void deny_module(interpreter *i, char *name, int flags);
enum deny_module_flags { deny_none, deny_loaded, deny_loading };

void attach_module(interpreter *i, char *name);

void init_modules(char *dlft);

void *get_mod_sym(char *modname, char *sym);
void *get_ma_data(module *mod, interpreter *i);

void append_builtins(interpreter *i, master_instruction_src *set);
void replace_builtins(interpreter *i, master_instruction_src *rep, instruction_t *saved);

void module_pragma(interpreter *i, char *name, char *pragma);
const char *module_version(char *name);
const char *module_date(char *name);

#endif
